diff --git a/src/backend/utils/cache/syscache.c b/src/backend/utils/cache/syscache.c
index 1912b12146..9751ad6a22 100644
--- a/src/backend/utils/cache/syscache.c
+++ b/src/backend/utils/cache/syscache.c
@@ -200,12 +200,12 @@ static const struct cachedesc cacheinfo[] = {
 		},
 		32
 	},
-	{AttributeRelationId,		/* ATTNUM */
-		AttributeRelidNumIndexId,
+	{AttributeRelationId,		/* ATTPHYSNUM */
+		AttributeRelidPhysNumIndexId,
 		2,
 		{
 			Anum_pg_attribute_attrelid,
-			Anum_pg_attribute_attnum,
+			Anum_pg_attribute_attphysnum,
 			0,
 			0
 		},
@@ -1368,19 +1368,19 @@ SearchSysCacheExistsAttName(Oid relid, const char *attname)
 /*
  * SearchSysCacheAttNum
  *
- * This routine is equivalent to SearchSysCache on the ATTNUM cache,
+ * This routine is equivalent to SearchSysCache on the ATTPHYSNUM cache,
  * except that it will return NULL if the found attribute is marked
  * attisdropped.  This is convenient for callers that want to act as
  * though dropped attributes don't exist.
  */
 HeapTuple
-SearchSysCacheAttNum(Oid relid, int16 attnum)
+SearchSysCacheAttNum(Oid relid, int16 attphysnum)
 {
 	HeapTuple	tuple;
 
-	tuple = SearchSysCache2(ATTNUM,
+	tuple = SearchSysCache2(ATTPHYSNUM,
 							ObjectIdGetDatum(relid),
-							Int16GetDatum(attnum));
+							Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(tuple))
 		return NULL;
 	if (((Form_pg_attribute) GETSTRUCT(tuple))->attisdropped)
@@ -1397,12 +1397,12 @@ SearchSysCacheAttNum(Oid relid, int16 attnum)
  * As above, an attisdropped-aware version of SearchSysCacheCopy.
  */
 HeapTuple
-SearchSysCacheCopyAttNum(Oid relid, int16 attnum)
+SearchSysCacheCopyAttNum(Oid relid, int16 attphysnum)
 {
 	HeapTuple	tuple,
 				newtuple;
 
-	tuple = SearchSysCacheAttNum(relid, attnum);
+	tuple = SearchSysCacheAttNum(relid, attphysnum);
 	if (!HeapTupleIsValid(tuple))
 		return NULL;
 	newtuple = heap_copytuple(tuple);
diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index ed6de7ca94..b6fb9391e7 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -1612,7 +1612,7 @@ setup_privileges(FILE *cmdfd)
 		"    SELECT"
 		"        pg_class.oid,"
 		"        (SELECT oid FROM pg_class WHERE relname = 'pg_class'),"
-		"        pg_attribute.attnum,"
+		"        pg_attribute.attphysnum,"
 		"        pg_attribute.attacl,"
 		"        'i'"
 		"    FROM"
diff --git a/src/bin/pg_amcheck/pg_amcheck.c b/src/bin/pg_amcheck/pg_amcheck.c
index 3cff319f02..dc043f73ae 100644
--- a/src/bin/pg_amcheck/pg_amcheck.c
+++ b/src/bin/pg_amcheck/pg_amcheck.c
@@ -802,7 +802,7 @@ prepare_heap_command(PQExpBuffer sql, RelationInfo *rel, PGconn *conn)
 {
 	resetPQExpBuffer(sql);
 	appendPQExpBuffer(sql,
-					  "SELECT v.blkno, v.offnum, v.attnum, v.msg "
+					  "SELECT v.blkno, v.offnum, v.attphysnum, v.msg "
 					  "FROM pg_catalog.pg_class c, %s.verify_heapam("
 					  "\nrelation := c.oid, on_error_stop := %s, check_toast := %s, skip := '%s'",
 					  rel->datinfo->amcheck_schema,
@@ -1016,7 +1016,7 @@ verify_heap_slot_handler(PGresult *res, PGconn *conn, void *context)
 					   rel->datinfo->datname, rel->nspname, rel->relname,
 					   PQgetvalue(res, i, 0),	/* blkno */
 					   PQgetvalue(res, i, 1),	/* offnum */
-					   PQgetvalue(res, i, 2));	/* attnum */
+					   PQgetvalue(res, i, 2));	/* attphysnum */
 
 			else if (!PQgetisnull(res, i, 1))
 				printf(_("heap table \"%s.%s.%s\", block %s, offset %s:\n"),
diff --git a/src/bin/pg_amcheck/t/003_check.pl b/src/bin/pg_amcheck/t/003_check.pl
index 0cf67065d6..224287e6f5 100644
--- a/src/bin/pg_amcheck/t/003_check.pl
+++ b/src/bin/pg_amcheck/t/003_check.pl
@@ -172,7 +172,7 @@ for my $dbname (qw(db1 db2 db3))
 											 endblock bigint default null,
 											 blkno OUT bigint,
 											 offnum OUT integer,
-											 attnum OUT integer,
+											 attphysnum OUT integer,
 											 msg OUT text)
 		RETURNS SETOF record AS $$
 		BEGIN
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index 7cc9c72e49..58e07f008c 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -4171,7 +4171,7 @@ getPublicationTables(Archive *fout, TableInfo tblinfo[], int numTables)
 							 "       FROM\n"
 							 "         pg_catalog.generate_series(0, pg_catalog.array_upper(pr.prattrs::pg_catalog.int2[], 1)) s,\n"
 							 "         pg_catalog.pg_attribute\n"
-							 "      WHERE attrelid = pr.prrelid AND attnum = prattrs[s])\n"
+							 "      WHERE attrelid = pr.prrelid AND attphysnum = prattrs[s])\n"
 							 "  ELSE NULL END) prattrs "
 							 "FROM pg_catalog.pg_publication_rel pr");
 	else
@@ -6719,11 +6719,11 @@ getIndexes(Archive *fout, TableInfo tblinfo[], int numTables)
 						  "inh.inhparent AS parentidx, "
 						  "i.indnkeyatts AS indnkeyatts, "
 						  "i.indnatts AS indnatts, "
-						  "(SELECT pg_catalog.array_agg(attnum ORDER BY attnum) "
+						  "(SELECT pg_catalog.array_agg(attphysnum ORDER BY attphysnum) "
 						  "  FROM pg_catalog.pg_attribute "
 						  "  WHERE attrelid = i.indexrelid AND "
 						  "    attstattarget >= 0) AS indstatcols, "
-						  "(SELECT pg_catalog.array_agg(attstattarget ORDER BY attnum) "
+						  "(SELECT pg_catalog.array_agg(attstattarget ORDER BY attphysnum) "
 						  "  FROM pg_catalog.pg_attribute "
 						  "  WHERE attrelid = i.indexrelid AND "
 						  "    attstattarget >= 0) AS indstatvals, ");
@@ -8130,7 +8130,7 @@ getTableAttrs(Archive *fout, TableInfo *tblinfo, int numTables)
 	appendPQExpBufferStr(q,
 						 "SELECT\n"
 						 "a.attrelid,\n"
-						 "a.attnum,\n"
+						 "a.attphysnum,\n"
 						 "a.attname,\n"
 						 "a.atttypmod,\n"
 						 "a.attstattarget,\n"
@@ -8188,8 +8188,8 @@ getTableAttrs(Archive *fout, TableInfo *tblinfo, int numTables)
 					  "JOIN pg_catalog.pg_attribute a ON (src.tbloid = a.attrelid) "
 					  "LEFT JOIN pg_catalog.pg_type t "
 					  "ON (a.atttypid = t.oid)\n"
-					  "WHERE a.attnum > 0::pg_catalog.int2\n"
-					  "ORDER BY a.attrelid, a.attnum",
+					  "WHERE a.attphysnum > 0::pg_catalog.int2\n"
+					  "ORDER BY a.attrelid, a.attphysnum",
 					  tbloids->data);
 
 	res = ExecuteSqlQuery(fout, q->data, PGRES_TUPLES_OK);
@@ -8197,7 +8197,7 @@ getTableAttrs(Archive *fout, TableInfo *tblinfo, int numTables)
 	ntups = PQntuples(res);
 
 	i_attrelid = PQfnumber(res, "attrelid");
-	i_attnum = PQfnumber(res, "attnum");
+	i_attnum = PQfnumber(res, "attphysnum");
 	i_attname = PQfnumber(res, "attname");
 	i_atttypname = PQfnumber(res, "atttypname");
 	i_atttypmod = PQfnumber(res, "atttypmod");
@@ -11010,7 +11010,7 @@ dumpCompositeType(Archive *fout, const TypeInfo *tyinfo)
 		 */
 		appendPQExpBufferStr(query,
 							 "PREPARE dumpCompositeType(pg_catalog.oid) AS\n"
-							 "SELECT a.attname, a.attnum, "
+							 "SELECT a.attname, a.attphysnum, "
 							 "pg_catalog.format_type(a.atttypid, a.atttypmod) AS atttypdefn, "
 							 "a.attlen, a.attalign, a.attisdropped, "
 							 "CASE WHEN a.attcollation <> at.typcollation "
@@ -11019,7 +11019,7 @@ dumpCompositeType(Archive *fout, const TypeInfo *tyinfo)
 							 "JOIN pg_catalog.pg_attribute a ON a.attrelid = ct.typrelid "
 							 "LEFT JOIN pg_catalog.pg_type at ON at.oid = a.atttypid "
 							 "WHERE ct.oid = $1 "
-							 "ORDER BY a.attnum");
+							 "ORDER BY a.attphysnum");
 
 		ExecuteSqlStatement(fout, query->data);
 
@@ -11214,7 +11214,7 @@ dumpCompositeTypeColComments(Archive *fout, const TypeInfo *tyinfo,
 	target = createPQExpBuffer();
 
 	ntups = PQntuples(res);
-	i_attnum = PQfnumber(res, "attnum");
+	i_attnum = PQfnumber(res, "attphysnum");
 	i_attname = PQfnumber(res, "attname");
 	i_attisdropped = PQfnumber(res, "attisdropped");
 	while (ncomments > 0)
@@ -14869,11 +14869,11 @@ dumpTable(Archive *fout, const TableInfo *tbinfo)
 									 "LEFT JOIN pg_catalog.pg_init_privs pip ON "
 									 "(at.attrelid = pip.objoid "
 									 "AND pip.classoid = 'pg_catalog.pg_class'::pg_catalog.regclass "
-									 "AND at.attnum = pip.objsubid) "
+									 "AND at.attphysnum = pip.objsubid) "
 									 "WHERE at.attrelid = $1 AND "
 									 "NOT at.attisdropped "
 									 "AND (at.attacl IS NOT NULL OR pip.initprivs IS NOT NULL) "
-									 "ORDER BY at.attnum");
+									 "ORDER BY at.attphysnum");
 			}
 			else
 			{
@@ -14883,7 +14883,7 @@ dumpTable(Archive *fout, const TableInfo *tbinfo)
 									 "FROM pg_catalog.pg_attribute "
 									 "WHERE attrelid = $1 AND NOT attisdropped "
 									 "AND attacl IS NOT NULL "
-									 "ORDER BY attnum");
+									 "ORDER BY attphysnum");
 			}
 
 			ExecuteSqlStatement(fout, query->data);
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index d1ae699171..a25ec298fd 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -1731,21 +1731,42 @@ describeOneTableDetails(const char *schemaname,
 			goto error_return;
 
 		/* Get the column that owns this sequence */
-		printfPQExpBuffer(&buf, "SELECT pg_catalog.quote_ident(nspname) || '.' ||"
-						  "\n   pg_catalog.quote_ident(relname) || '.' ||"
-						  "\n   pg_catalog.quote_ident(attname),"
-						  "\n   d.deptype"
-						  "\nFROM pg_catalog.pg_class c"
-						  "\nINNER JOIN pg_catalog.pg_depend d ON c.oid=d.refobjid"
-						  "\nINNER JOIN pg_catalog.pg_namespace n ON n.oid=c.relnamespace"
-						  "\nINNER JOIN pg_catalog.pg_attribute a ON ("
-						  "\n a.attrelid=c.oid AND"
-						  "\n a.attnum=d.refobjsubid)"
-						  "\nWHERE d.classid='pg_catalog.pg_class'::pg_catalog.regclass"
-						  "\n AND d.refclassid='pg_catalog.pg_class'::pg_catalog.regclass"
-						  "\n AND d.objid='%s'"
-						  "\n AND d.deptype IN ('a', 'i')",
-						  oid);
+		if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+		{
+			printfPQExpBuffer(&buf, "SELECT pg_catalog.quote_ident(nspname) || '.' ||"
+							  "\n   pg_catalog.quote_ident(relname) || '.' ||"
+							  "\n   pg_catalog.quote_ident(attname),"
+							  "\n   d.deptype"
+							  "\nFROM pg_catalog.pg_class c"
+							  "\nINNER JOIN pg_catalog.pg_depend d ON c.oid=d.refobjid"
+							  "\nINNER JOIN pg_catalog.pg_namespace n ON n.oid=c.relnamespace"
+							  "\nINNER JOIN pg_catalog.pg_attribute a ON ("
+							  "\n a.attrelid=c.oid AND"
+							  "\n a.attphysnum=d.refobjsubid)"
+							  "\nWHERE d.classid='pg_catalog.pg_class'::pg_catalog.regclass"
+							  "\n AND d.refclassid='pg_catalog.pg_class'::pg_catalog.regclass"
+							  "\n AND d.objid='%s'"
+							  "\n AND d.deptype IN ('a', 'i')",
+							  oid);
+		}
+		else
+		{
+			printfPQExpBuffer(&buf, "SELECT pg_catalog.quote_ident(nspname) || '.' ||"
+							  "\n   pg_catalog.quote_ident(relname) || '.' ||"
+							  "\n   pg_catalog.quote_ident(attname),"
+							  "\n   d.deptype"
+							  "\nFROM pg_catalog.pg_class c"
+							  "\nINNER JOIN pg_catalog.pg_depend d ON c.oid=d.refobjid"
+							  "\nINNER JOIN pg_catalog.pg_namespace n ON n.oid=c.relnamespace"
+							  "\nINNER JOIN pg_catalog.pg_attribute a ON ("
+							  "\n a.attrelid=c.oid AND"
+							  "\n a.attnum=d.refobjsubid)"
+							  "\nWHERE d.classid='pg_catalog.pg_class'::pg_catalog.regclass"
+							  "\n AND d.refclassid='pg_catalog.pg_class'::pg_catalog.regclass"
+							  "\n AND d.objid='%s'"
+							  "\n AND d.deptype IN ('a', 'i')",
+							  oid);
+		}
 
 		result = PSQLexec(buf.data);
 
@@ -1819,11 +1840,23 @@ describeOneTableDetails(const char *schemaname,
 	if (show_column_details)
 	{
 		/* use "pretty" mode for expression to avoid excessive parentheses */
-		appendPQExpBufferStr(&buf,
-							 ",\n  (SELECT pg_catalog.pg_get_expr(d.adbin, d.adrelid, true)"
-							 "\n   FROM pg_catalog.pg_attrdef d"
-							 "\n   WHERE d.adrelid = a.attrelid AND d.adnum = a.attnum AND a.atthasdef)"
-							 ",\n  a.attnotnull");
+		if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+		{
+			appendPQExpBufferStr(&buf,
+								 ",\n  (SELECT pg_catalog.pg_get_expr(d.adbin, d.adrelid, true)"
+								 "\n   FROM pg_catalog.pg_attrdef d"
+								 "\n   WHERE d.adrelid = a.attrelid AND d.adnum = a.attphysnum AND a.atthasdef)"
+								 ",\n  a.attnotnull");
+		}
+		else
+		{
+			appendPQExpBufferStr(&buf,
+								 ",\n  (SELECT pg_catalog.pg_get_expr(d.adbin, d.adrelid, true)"
+								 "\n   FROM pg_catalog.pg_attrdef d"
+								 "\n   WHERE d.adrelid = a.attrelid AND d.adnum = a.attnum AND a.atthasdef)"
+								 ",\n  a.attnotnull");
+		}
+
 		attrdef_col = cols++;
 		attnotnull_col = cols++;
 		appendPQExpBufferStr(&buf, ",\n  (SELECT c.collname FROM pg_catalog.pg_collation c, pg_catalog.pg_type t\n"
@@ -1843,7 +1876,15 @@ describeOneTableDetails(const char *schemaname,
 	if (tableinfo.relkind == RELKIND_INDEX ||
 		tableinfo.relkind == RELKIND_PARTITIONED_INDEX)
 	{
-		if (pset.sversion >= 110000)
+		if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+		{
+			appendPQExpBuffer(&buf, ",\n  CASE WHEN a.attphysnum <= (SELECT i.indnkeyatts FROM pg_catalog.pg_index i WHERE i.indexrelid = '%s') THEN '%s' ELSE '%s' END AS is_key",
+							  oid,
+							  gettext_noop("yes"),
+							  gettext_noop("no"));
+			isindexkey_col = cols++;
+		}
+		else if (pset.sversion >= 110000)
 		{
 			appendPQExpBuffer(&buf, ",\n  CASE WHEN a.attnum <= (SELECT i.indnkeyatts FROM pg_catalog.pg_index i WHERE i.indexrelid = '%s') THEN '%s' ELSE '%s' END AS is_key",
 							  oid,
@@ -1851,7 +1892,11 @@ describeOneTableDetails(const char *schemaname,
 							  gettext_noop("no"));
 			isindexkey_col = cols++;
 		}
-		appendPQExpBufferStr(&buf, ",\n  pg_catalog.pg_get_indexdef(a.attrelid, a.attnum, TRUE) AS indexdef");
+
+		if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+			appendPQExpBufferStr(&buf, ",\n  pg_catalog.pg_get_indexdef(a.attrelid, a.attphysnum, TRUE) AS indexdef");
+		else
+			appendPQExpBufferStr(&buf, ",\n  pg_catalog.pg_get_indexdef(a.attrelid, a.attnum, TRUE) AS indexdef");
 		indexdef_col = cols++;
 	}
 	/* FDW options for foreign table column */
@@ -1901,14 +1946,25 @@ describeOneTableDetails(const char *schemaname,
 			tableinfo.relkind == RELKIND_COMPOSITE_TYPE ||
 			tableinfo.relkind == RELKIND_PARTITIONED_TABLE)
 		{
-			appendPQExpBufferStr(&buf, ",\n  pg_catalog.col_description(a.attrelid, a.attnum)");
+			if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+				appendPQExpBufferStr(&buf, ",\n  pg_catalog.col_description(a.attrelid, a.attphysnum)");
+			else
+				appendPQExpBufferStr(&buf, ",\n  pg_catalog.col_description(a.attrelid, a.attnum)");
 			attdescr_col = cols++;
 		}
 	}
 
 	appendPQExpBufferStr(&buf, "\nFROM pg_catalog.pg_attribute a");
-	appendPQExpBuffer(&buf, "\nWHERE a.attrelid = '%s' AND a.attnum > 0 AND NOT a.attisdropped", oid);
-	appendPQExpBufferStr(&buf, "\nORDER BY a.attnum;");
+	if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+	{
+		appendPQExpBuffer(&buf, "\nWHERE a.attrelid = '%s' AND a.attphysnum > 0 AND NOT a.attisdropped", oid);
+		appendPQExpBufferStr(&buf, "\nORDER BY a.attphysnum;");
+	}
+	else
+	{
+		appendPQExpBuffer(&buf, "\nWHERE a.attrelid = '%s' AND a.attnum > 0 AND NOT a.attisdropped", oid);
+		appendPQExpBufferStr(&buf, "\nORDER BY a.attnum;");
+	}
 
 	res = PSQLexec(buf.data);
 	if (!res)
@@ -2930,7 +2986,39 @@ describeOneTableDetails(const char *schemaname,
 		/* print any publications */
 		if (pset.sversion >= 100000)
 		{
-			if (pset.sversion >= 150000)
+			if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+			{
+				printfPQExpBuffer(&buf,
+								  "SELECT pubname\n"
+								  "     , NULL\n"
+								  "     , NULL\n"
+								  "FROM pg_catalog.pg_publication p\n"
+								  "     JOIN pg_catalog.pg_publication_namespace pn ON p.oid = pn.pnpubid\n"
+								  "     JOIN pg_catalog.pg_class pc ON pc.relnamespace = pn.pnnspid\n"
+								  "WHERE pc.oid ='%s' and pg_catalog.pg_relation_is_publishable('%s')\n"
+								  "UNION\n"
+								  "SELECT pubname\n"
+								  "     , pg_get_expr(pr.prqual, c.oid)\n"
+								  "     , (CASE WHEN pr.prattrs IS NOT NULL THEN\n"
+								  "         (SELECT string_agg(attname, ', ')\n"
+								  "           FROM pg_catalog.generate_series(0, pg_catalog.array_upper(pr.prattrs::pg_catalog.int2[], 1)) s,\n"
+								  "                pg_catalog.pg_attribute\n"
+								  "          WHERE attrelid = pr.prrelid AND attphysnum = prattrs[s])\n"
+								  "        ELSE NULL END) "
+								  "FROM pg_catalog.pg_publication p\n"
+								  "     JOIN pg_catalog.pg_publication_rel pr ON p.oid = pr.prpubid\n"
+								  "     JOIN pg_catalog.pg_class c ON c.oid = pr.prrelid\n"
+								  "WHERE pr.prrelid = '%s'\n"
+								  "UNION\n"
+								  "SELECT pubname\n"
+								  "     , NULL\n"
+								  "     , NULL\n"
+								  "FROM pg_catalog.pg_publication p\n"
+								  "WHERE p.puballtables AND pg_catalog.pg_relation_is_publishable('%s')\n"
+								  "ORDER BY 1;",
+								  oid, oid, oid, oid);
+			}
+			else if (pset.sversion >= 150000)
 			{
 				printfPQExpBuffer(&buf,
 								  "SELECT pubname\n"
@@ -4609,7 +4697,7 @@ listExtendedStats(const char *pattern)
 						  "   FROM pg_catalog.unnest(es.stxkeys) s(attnum) \n"
 						  "   JOIN pg_catalog.pg_attribute a \n"
 						  "   ON (es.stxrelid = a.attrelid \n"
-						  "   AND a.attnum = s.attnum \n"
+						  "   AND a.attnum = s.attsnum \n"
 						  "   AND NOT a.attisdropped)), \n"
 						  "es.stxrelid::pg_catalog.regclass) AS \"%s\"",
 						  gettext_noop("Definition"));
@@ -6279,7 +6367,21 @@ describePublications(const char *pattern)
 			/* Get the tables for the specified publication */
 			printfPQExpBuffer(&buf,
 							  "SELECT n.nspname, c.relname");
-			if (pset.sversion >= 150000)
+			if (pset.sversion >= 150000) /* FIXME - bump me when pg15 branched */
+			{
+				appendPQExpBufferStr(&buf,
+									 ", pg_get_expr(pr.prqual, c.oid)");
+				appendPQExpBufferStr(&buf,
+									 ", (CASE WHEN pr.prattrs IS NOT NULL THEN\n"
+									 "     pg_catalog.array_to_string("
+									 "      ARRAY(SELECT attname\n"
+									 "              FROM\n"
+									 "                pg_catalog.generate_series(0, pg_catalog.array_upper(pr.prattrs::pg_catalog.int2[], 1)) s,\n"
+									 "                pg_catalog.pg_attribute\n"
+									 "        WHERE attrelid = c.oid AND attphysnum = prattrs[s]), ', ')\n"
+									 "       ELSE NULL END)");
+			}
+			else if (pset.sversion >= 150000)
 			{
 				appendPQExpBufferStr(&buf,
 									 ", pg_get_expr(pr.prqual, c.oid)");
diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
index bd44a1d55d..df5df475b8 100644
--- a/src/bin/psql/tab-complete.c
+++ b/src/bin/psql/tab-complete.c
@@ -516,7 +516,7 @@ static const SchemaQuery Query_for_list_of_arguments = {
 
 static const SchemaQuery Query_for_list_of_attributes = {
 	.catname = "pg_catalog.pg_attribute a, pg_catalog.pg_class c",
-	.selcondition = "c.oid = a.attrelid and a.attnum > 0 and not a.attisdropped",
+	.selcondition = "c.oid = a.attrelid and a.attphysnum > 0 and not a.attisdropped",
 	.result = "a.attname",
 	.refname = "c.relname",
 	.refviscondition = "pg_catalog.pg_table_is_visible(c.oid)",
@@ -525,7 +525,7 @@ static const SchemaQuery Query_for_list_of_attributes = {
 
 static const SchemaQuery Query_for_list_of_attribute_numbers = {
 	.catname = "pg_catalog.pg_attribute a, pg_catalog.pg_class c",
-	.selcondition = "c.oid = a.attrelid and a.attnum > 0 and not a.attisdropped",
+	.selcondition = "c.oid = a.attrelid and a.attphysnum > 0 and not a.attisdropped",
 	.result = "a.attnum::pg_catalog.text",
 	.refname = "c.relname",
 	.refviscondition = "pg_catalog.pg_table_is_visible(c.oid)",
diff --git a/src/include/access/genam.h b/src/include/access/genam.h
index 134b20f1e6..4d95e2801a 100644
--- a/src/include/access/genam.h
+++ b/src/include/access/genam.h
@@ -183,15 +183,15 @@ extern IndexBulkDeleteResult *index_bulk_delete(IndexVacuumInfo *info,
 extern IndexBulkDeleteResult *index_vacuum_cleanup(IndexVacuumInfo *info,
 												   IndexBulkDeleteResult *istat);
 extern bool index_can_return(Relation indexRelation, int attno);
-extern RegProcedure index_getprocid(Relation irel, AttrNumber attnum,
+extern RegProcedure index_getprocid(Relation irel, AttrNumber attphysnum,
 									uint16 procnum);
-extern FmgrInfo *index_getprocinfo(Relation irel, AttrNumber attnum,
+extern FmgrInfo *index_getprocinfo(Relation irel, AttrNumber attphysnum,
 								   uint16 procnum);
 extern void index_store_float8_orderby_distances(IndexScanDesc scan,
 												 Oid *orderByTypes,
 												 IndexOrderByDistance *distances,
 												 bool recheckOrderBy);
-extern bytea *index_opclass_options(Relation relation, AttrNumber attnum,
+extern bytea *index_opclass_options(Relation relation, AttrNumber attphysnum,
 									Datum attoptions, bool validate);
 
 
diff --git a/src/include/access/gin_private.h b/src/include/access/gin_private.h
index 2935d2f353..733686d724 100644
--- a/src/include/access/gin_private.h
+++ b/src/include/access/gin_private.h
@@ -95,13 +95,13 @@ extern Buffer GinNewBuffer(Relation index);
 extern void GinInitBuffer(Buffer b, uint32 f);
 extern void GinInitPage(Page page, uint32 f, Size pageSize);
 extern void GinInitMetabuffer(Buffer b);
-extern int	ginCompareEntries(GinState *ginstate, OffsetNumber attnum,
+extern int	ginCompareEntries(GinState *ginstate, OffsetNumber attphysnum,
 							  Datum a, GinNullCategory categorya,
 							  Datum b, GinNullCategory categoryb);
 extern int	ginCompareAttEntries(GinState *ginstate,
 								 OffsetNumber attnuma, Datum a, GinNullCategory categorya,
 								 OffsetNumber attnumb, Datum b, GinNullCategory categoryb);
-extern Datum *ginExtractEntries(GinState *ginstate, OffsetNumber attnum,
+extern Datum *ginExtractEntries(GinState *ginstate, OffsetNumber attphysnum,
 								Datum value, bool isNull,
 								int32 *nentries, GinNullCategory **categories);
 
@@ -119,7 +119,7 @@ extern bool gininsert(Relation index, Datum *values, bool *isnull,
 					  bool indexUnchanged,
 					  struct IndexInfo *indexInfo);
 extern void ginEntryInsert(GinState *ginstate,
-						   OffsetNumber attnum, Datum key, GinNullCategory category,
+						   OffsetNumber attphysnum, Datum key, GinNullCategory category,
 						   ItemPointerData *items, uint32 nitem,
 						   GinStatsData *buildStats);
 
@@ -210,13 +210,13 @@ extern void ginInsertValue(GinBtree btree, GinBtreeStack *stack,
 
 /* ginentrypage.c */
 extern IndexTuple GinFormTuple(GinState *ginstate,
-							   OffsetNumber attnum, Datum key, GinNullCategory category,
+							   OffsetNumber attphysnum, Datum key, GinNullCategory category,
 							   Pointer data, Size dataSize, int nipd, bool errorTooBig);
-extern void ginPrepareEntryScan(GinBtree btree, OffsetNumber attnum,
+extern void ginPrepareEntryScan(GinBtree btree, OffsetNumber attphysnum,
 								Datum key, GinNullCategory category,
 								GinState *ginstate);
 extern void ginEntryFillRoot(GinBtree btree, Page root, BlockNumber lblkno, Page lpage, BlockNumber rblkno, Page rpage);
-extern ItemPointer ginReadTuple(GinState *ginstate, OffsetNumber attnum,
+extern ItemPointer ginReadTuple(GinState *ginstate, OffsetNumber attphysnum,
 								IndexTuple itup, int *nitems);
 
 /* gindatapage.c */
@@ -302,7 +302,7 @@ typedef struct GinScanKeyData
 	Pointer    *extra_data;
 	StrategyNumber strategy;
 	int32		searchMode;
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 
 	/*
 	 * An excludeOnly scan key is not able to enumerate all matching tuples.
@@ -340,7 +340,7 @@ typedef struct GinScanEntryData
 	Pointer		extra_data;
 	StrategyNumber strategy;
 	int32		searchMode;
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 
 	/* Current page in posting tree */
 	Buffer		buffer;
@@ -419,7 +419,7 @@ typedef struct GinEntryAccumulator
 	RBTNode		rbtnode;
 	Datum		key;
 	GinNullCategory category;
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 	bool		shouldSort;
 	ItemPointerData *list;
 	uint32		maxcount;		/* allocated size of list[] */
@@ -438,12 +438,12 @@ typedef struct
 
 extern void ginInitBA(BuildAccumulator *accum);
 extern void ginInsertBAEntries(BuildAccumulator *accum,
-							   ItemPointer heapptr, OffsetNumber attnum,
+							   ItemPointer heapptr, OffsetNumber attphysnum,
 							   Datum *entries, GinNullCategory *categories,
 							   int32 nentries);
 extern void ginBeginBAScan(BuildAccumulator *accum);
 extern ItemPointerData *ginGetBAEntry(BuildAccumulator *accum,
-									  OffsetNumber *attnum, Datum *key, GinNullCategory *category,
+									  OffsetNumber *attphysnum, Datum *key, GinNullCategory *category,
 									  uint32 *n);
 
 /* ginfast.c */
@@ -460,7 +460,7 @@ extern void ginHeapTupleFastInsert(GinState *ginstate,
 								   GinTupleCollector *collector);
 extern void ginHeapTupleFastCollect(GinState *ginstate,
 									GinTupleCollector *collector,
-									OffsetNumber attnum, Datum value, bool isNull,
+									OffsetNumber attphysnum, Datum value, bool isNull,
 									ItemPointer ht_ctid);
 extern void ginInsertCleanup(GinState *ginstate, bool full_clean,
 							 bool fill_fsm, bool forceCleanup, IndexBulkDeleteResult *stats);
diff --git a/src/include/access/htup_details.h b/src/include/access/htup_details.h
index 51a60eda08..a04c5df02e 100644
--- a/src/include/access/htup_details.h
+++ b/src/include/access/htup_details.h
@@ -697,13 +697,13 @@ extern void heap_fill_tuple(TupleDesc tupleDesc,
 							Datum *values, bool *isnull,
 							char *data, Size data_size,
 							uint16 *infomask, bits8 *bit);
-extern bool heap_attisnull(HeapTuple tup, int attnum, TupleDesc tupleDesc);
-extern Datum nocachegetattr(HeapTuple tup, int attnum,
+extern bool heap_attisnull(HeapTuple tup, int attphysnum, TupleDesc tupleDesc);
+extern Datum nocachegetattr(HeapTuple tup, int attphysnum,
 							TupleDesc att);
-extern Datum heap_getsysattr(HeapTuple tup, int attnum, TupleDesc tupleDesc,
+extern Datum heap_getsysattr(HeapTuple tup, int attphysnum, TupleDesc tupleDesc,
 							 bool *isnull);
 extern Datum getmissingattr(TupleDesc tupleDesc,
-							int attnum, bool *isnull);
+							int attphysnum, bool *isnull);
 extern HeapTuple heap_copytuple(HeapTuple tuple);
 extern void heap_copytuple_with_tuple(HeapTuple src, HeapTuple dest);
 extern Datum heap_copy_tuple_as_datum(HeapTuple tuple, TupleDesc tupleDesc);
@@ -740,45 +740,45 @@ extern MinimalTuple minimal_expand_tuple(HeapTuple sourceTuple, TupleDesc tupleD
  *		value, or a pointer into the data area of the tuple).
  *
  *		This must not be used when a system attribute might be requested.
- *		Furthermore, the passed attnum MUST be valid.  Use heap_getattr()
+ *		Furthermore, the passed attphysnum MUST be valid.  Use heap_getattr()
  *		instead, if in doubt.
  *
  *		This gets called many times, so we macro the cacheable and NULL
  *		lookups, and call nocachegetattr() for the rest.
  */
 static inline Datum
-fastgetattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
+fastgetattr(HeapTuple tup, int attphysnum, TupleDesc tupleDesc, bool *isnull)
 {
-	Assert(attnum > 0);
+	Assert(attphysnum > 0);
 
 	*isnull = false;
 	if (HeapTupleNoNulls(tup))
 	{
 		Form_pg_attribute att;
 
-		att = TupleDescAttr(tupleDesc, attnum - 1);
+		att = TupleDescAttr(tupleDesc, attphysnum - 1);
 		if (att->attcacheoff >= 0)
 			return fetchatt(att, (char *) tup->t_data + tup->t_data->t_hoff +
 							att->attcacheoff);
 		else
-			return nocachegetattr(tup, attnum, tupleDesc);
+			return nocachegetattr(tup, attphysnum, tupleDesc);
 	}
 	else
 	{
-		if (att_isnull(attnum - 1, tup->t_data->t_bits))
+		if (att_isnull(attphysnum - 1, tup->t_data->t_bits))
 		{
 			*isnull = true;
 			return (Datum) NULL;
 		}
 		else
-			return nocachegetattr(tup, attnum, tupleDesc);
+			return nocachegetattr(tup, attphysnum, tupleDesc);
 	}
 }
 
 /*
  *	heap_getattr
  *		Extract an attribute of a heap tuple and return it as a Datum.
- *		This works for either system or user attributes.  The given attnum
+ *		This works for either system or user attributes.  The given attphysnum
  *		is properly range-checked.
  *
  *		If the field in question has a NULL value, we return a zero Datum
@@ -790,17 +790,17 @@ fastgetattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
  *
  */
 static inline Datum
-heap_getattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
+heap_getattr(HeapTuple tup, int attphysnum, TupleDesc tupleDesc, bool *isnull)
 {
-	if (attnum > 0)
+	if (attphysnum > 0)
 	{
-		if (attnum > (int) HeapTupleHeaderGetNatts(tup->t_data))
-			return getmissingattr(tupleDesc, attnum, isnull);
+		if (attphysnum > (int) HeapTupleHeaderGetNatts(tup->t_data))
+			return getmissingattr(tupleDesc, attphysnum, isnull);
 		else
-			return fastgetattr(tup, attnum, tupleDesc, isnull);
+			return fastgetattr(tup, attphysnum, tupleDesc, isnull);
 	}
 	else
-		return heap_getsysattr(tup, attnum, tupleDesc, isnull);
+		return heap_getsysattr(tup, attphysnum, tupleDesc, isnull);
 }
 #endif							/* FRONTEND */
 
diff --git a/src/include/access/itup.h b/src/include/access/itup.h
index 2c8877e991..c31a20d53f 100644
--- a/src/include/access/itup.h
+++ b/src/include/access/itup.h
@@ -97,31 +97,31 @@ typedef IndexAttributeBitMapData * IndexAttributeBitMap;
  *
  * ----------------
  */
-#define index_getattr(tup, attnum, tupleDesc, isnull) \
+#define index_getattr(tup, attphysnum, tupleDesc, isnull) \
 ( \
-	AssertMacro(PointerIsValid(isnull) && (attnum) > 0), \
+	AssertMacro(PointerIsValid(isnull) && (attphysnum) > 0), \
 	*(isnull) = false, \
 	!IndexTupleHasNulls(tup) ? \
 	( \
-		TupleDescAttr((tupleDesc), (attnum)-1)->attcacheoff >= 0 ? \
+		TupleDescAttr((tupleDesc), (attphysnum)-1)->attcacheoff >= 0 ? \
 		( \
-			fetchatt(TupleDescAttr((tupleDesc), (attnum)-1), \
+			fetchatt(TupleDescAttr((tupleDesc), (attphysnum)-1), \
 			(char *) (tup) + IndexInfoFindDataOffset((tup)->t_info) \
-			+ TupleDescAttr((tupleDesc), (attnum)-1)->attcacheoff) \
+			+ TupleDescAttr((tupleDesc), (attphysnum)-1)->attcacheoff) \
 		) \
 		: \
-			nocache_index_getattr((tup), (attnum), (tupleDesc)) \
+			nocache_index_getattr((tup), (attphysnum), (tupleDesc)) \
 	) \
 	: \
 	( \
-		(att_isnull((attnum)-1, (char *)(tup) + sizeof(IndexTupleData))) ? \
+		(att_isnull((attphysnum)-1, (char *)(tup) + sizeof(IndexTupleData))) ? \
 		( \
 			*(isnull) = true, \
 			(Datum)NULL \
 		) \
 		: \
 		( \
-			nocache_index_getattr((tup), (attnum), (tupleDesc)) \
+			nocache_index_getattr((tup), (attphysnum), (tupleDesc)) \
 		) \
 	) \
 )
@@ -150,7 +150,7 @@ typedef IndexAttributeBitMapData * IndexAttributeBitMap;
 /* routines in indextuple.c */
 extern IndexTuple index_form_tuple(TupleDesc tupleDescriptor,
 								   Datum *values, bool *isnull);
-extern Datum nocache_index_getattr(IndexTuple tup, int attnum,
+extern Datum nocache_index_getattr(IndexTuple tup, int attphysnum,
 								   TupleDesc tupleDesc);
 extern void index_deform_tuple(IndexTuple tup, TupleDesc tupleDescriptor,
 							   Datum *values, bool *isnull);
diff --git a/src/include/bootstrap/bootstrap.h b/src/include/bootstrap/bootstrap.h
index 49d4ad560f..cd4c2590f3 100644
--- a/src/include/bootstrap/bootstrap.h
+++ b/src/include/bootstrap/bootstrap.h
@@ -37,7 +37,7 @@ extern void BootstrapModeMain(int argc, char *argv[], bool check_only) pg_attrib
 extern void closerel(char *name);
 extern void boot_openrel(char *name);
 
-extern void DefineAttr(char *name, char *type, int attnum, int nullness);
+extern void DefineAttr(char *name, char *type, int attphysnum, int nullness);
 extern void InsertOneTuple(void);
 extern void InsertOneValue(char *value, int i);
 extern void InsertOneNull(int i);
